//<editor-fold defaultstate="collapsed" desc=" COPYRIGHT AND LICENSE ">
/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved.
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.mappers.Isovolume;

import javax.swing.JPanel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.vn.gui.widgets.RunButton;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends JPanel
{

    private Params params;

    /**
     * Creates new form IsosurfaceUI
     */
    public GUI()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel3 = new javax.swing.JPanel();
        belowButton = new javax.swing.JRadioButton();
        aboveButton = new javax.swing.JRadioButton();
        thresholdUI = new org.visnow.vn.lib.gui.ComponentBasedUI.value.ComponentValueUI();
        runButton1 = new org.visnow.vn.gui.widgets.RunButton();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setLayout(new java.awt.GridBagLayout());

        jPanel3.setLayout(new java.awt.GridLayout(1, 0));

        buttonGroup1.add(belowButton);
        belowButton.setText("below"); // NOI18N
        belowButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                belowButtonActionPerformed(evt);
            }
        });
        jPanel3.add(belowButton);

        buttonGroup1.add(aboveButton);
        aboveButton.setSelected(true);
        aboveButton.setText("above"); // NOI18N
        aboveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboveButtonActionPerformed(evt);
            }
        });
        jPanel3.add(aboveButton);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        add(jPanel3, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(thresholdUI, gridBagConstraints);

        runButton1.addUserActionListener(new org.visnow.vn.gui.swingwrappers.UserActionListener() {
            public void userAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
            }
            public void userChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt) {
                runButton1UserChangeAction(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.EAST;
        add(runButton1, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.weighty = 1.0;
        add(filler1, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void belowButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_belowButtonActionPerformed
    {//GEN-HEADEREND:event_belowButtonActionPerformed
        setPosition();
        runButton1.setPendingIfNoAuto();
    }//GEN-LAST:event_belowButtonActionPerformed

    private void aboveButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_aboveButtonActionPerformed
    {//GEN-HEADEREND:event_aboveButtonActionPerformed
        setPosition();
        runButton1.setPendingIfNoAuto();
    }//GEN-LAST:event_aboveButtonActionPerformed

    private void runButton1UserChangeAction(org.visnow.vn.gui.swingwrappers.UserEvent evt)//GEN-FIRST:event_runButton1UserChangeAction
    {//GEN-HEADEREND:event_runButton1UserChangeAction
        params.setRunState(RunButton.RunState.RUN_ONCE);
    }//GEN-LAST:event_runButton1UserChangeAction

    private void setPosition()
    {
        if (belowButton.isSelected())
            params.setType(-1);
        else
            params.setType(1);
    }

    public void setParams(Params params)
    {
        this.params = params;
        thresholdUI.setComponentValue(params.getThreshold());
        params.getThreshold().addChangeListener(new ChangeListener()
        {
            @Override
            public void stateChanged(ChangeEvent evt) {
                runButton1.setPendingIfNoAuto();
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JRadioButton aboveButton;
    public javax.swing.JRadioButton belowButton;
    public javax.swing.ButtonGroup buttonGroup1;
    public javax.swing.Box.Filler filler1;
    public javax.swing.JPanel jPanel3;
    public org.visnow.vn.gui.widgets.RunButton runButton1;
    public org.visnow.vn.lib.gui.ComponentBasedUI.value.ComponentValueUI thresholdUI;
    // End of variables declaration//GEN-END:variables

}
